Record (Java SE 14 & JDK 14)
Description: declaration: module: java.base, package: java.lang, class: Record
Keywords: java.lang.Record class

Module java.base
Package java.lang

# Class Record

java.lang.Object
java.lang.Record

    public abstract class Record
    extends Object

This class is associated with records, a preview feature of the Java language. Programs can only use this class when preview features are enabled. Preview features may be removed in a future release, or upgraded to permanent features of the Java language.
This is the common base class of all Java language record classes.

More information about records, including descriptions of the implicitly declared methods synthesized by the compiler, can be found in section 8.10 of The Java™ Language Specification.

A record class is a shallowly immutable, transparent carrier for a fixed set of values, called the record components. The Java™ language provides concise syntax for declaring record classes, whereby the record components are declared in the record header. The list of record components declared in the record header form the record descriptor.

A record class has the following mandated members: a public canonical constructor, whose descriptor is the same as the record descriptor; a private final field corresponding to each component, whose name and type are the same as that of the component; a public accessor method corresponding to each component, whose name and return type are the same as that of the component. If not explicitly declared in the body of the record, implicit implementations for these members are provided.

The implicit declaration of the canonical constructor initializes the component fields from the corresponding constructor arguments. The implicit declaration of the accessor methods returns the value of the corresponding component field. The implicit declaration of the `Object.equals(Object)`, `Object.hashCode()`, and `Object.toString()` methods are derived from all of the component fields.

The primary reasons to provide an explicit declaration for the canonical constructor or accessor methods are to validate constructor arguments, perform defensive copies on mutable components, or normalize groups of components (such as reducing a rational number to lowest terms.)

For all record classes, the following invariant must hold: if a record R's components are `c1, c2, ... cn`, then if a record instance is copied as follows:

         R copy = new R(r.c1(), r.c2(), ..., r.cn());

then it must be the case that `r.equals(copy)`.

API Note:
  A record class that `implements` `Serializable` is said to be a serializable record. Serializable records are serialized and deserialized differently than ordinary serializable objects. During deserialization the record's canonical constructor is invoked to construct the record object. Certain serialization-related methods, such as readObject and writeObject, are ignored for serializable records. More information about serializable records can be found in record serialization.
See Java Language Specification:
  8.10 Record Types
Since:
  14

- ## Constructor Summary

  Constructors
  Modifier | Constructor | Description
  --- | --- | ---
  `protected` | `Record()` | Constructor for record classes to call.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `abstract boolean` | `equals​(Object obj)` | Indicates whether some other object is "equal to" this one.
  `abstract int` | `hashCode()` | Obeys the general contract of `Object.hashCode`.
  `abstract String` | `toString()` | Obeys the general contract of `Object.toString`.

  ### Methods declared in class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Record

    protected Record()
    Constructor for record classes to call.

- ## Method Details

  - ### equals

    public abstract boolean equals​(Object obj)
    Indicates whether some other object is "equal to" this one. In addition to the general contract of `Object.equals`, record classes must further obey the invariant that when a record instance is "copied" by passing the result of the record component accessor methods to the canonical constructor, as follows:

             R copy = new R(r.c1(), r.c2(), ..., r.cn());

    then it must be the case that `r.equals(copy)`.
    Overrides:
      `equals` in class `Object`
    Implementation Requirements:
      The implicitly provided implementation returns `true` if and only if the argument is an instance of the same record type as this object, and each component of this record is equal to the corresponding component of the argument; otherwise, `false` is returned. Equality of a component `c` is determined as follows:
      - If the component is of a reference type, the component is considered equal if and only if `Objects.equals(this.c(), r.c()` would return `true`.
      - If the component is of a primitive type, using the corresponding primitive wrapper class `PW` (the corresponding wrapper class for `int` is `java.lang.Integer`, and so on), the component is considered equal if and only if `PW.valueOf(this.c()).equals(PW.valueOf(r.c()))` would return `true`.
      The implicitly provided implementation conforms to the semantics described above; the implementation may or may not accomplish this by using calls to the particular methods listed.
    Parameters:
      `obj` - the reference object with which to compare.
    Returns:
      `true` if this object is equal to the argument; `false` otherwise.
    See Also:
      `Objects.equals(Object,Object)`

  - ### hashCode

    public abstract int hashCode()
    Obeys the general contract of `Object.hashCode`.
    Overrides:
      `hashCode` in class `Object`
    Implementation Requirements:
      The implicitly provided implementation returns a hash code value derived by combining the hash code value for all the components, according to `Object.hashCode()` for components whose types are reference types, or the primitive wrapper hash code for components whose types are primitive types.
    Returns:
      a hash code value for this object.
    See Also:
      `Object.hashCode()`

  - ### toString

    public abstract String toString()
    Obeys the general contract of `Object.toString`.
    Overrides:
      `toString` in class `Object`
    Implementation Requirements:
      The implicitly provided implementation returns a string that is derived from the name of the record class and the names and string representations of all the components, according to `Object.toString()` for components whose types are reference types, and the primitive wrapper `toString` method for components whose types are primitive types.
    Returns:
      a string representation of the object.
    See Also:
      `Object.toString()`